# Create an ERC-20 token

Creating an ERC-20 token steps are pretty much the same steps as deploying a smart contract, the only difference is the contract code. You will be able to create an ERC-20 token that can be a memecoin, an utility cryptocurrency, a social token, etc. Let's go over the steps with the Hardhat example and using battle-tested [Open Zeppelin contracts](https://github.com/OpenZeppelin/openzeppelin-contracts):&#x20;

**Requirements**

* Node.js and npm: download and install both packages [here](https://docs.npmjs.com/downloading-and-installing-node-js-and-npm)
* Ethereum Wallet: [Metamask](https://metamask.io) or any other non-custodial Ethereum wallet, since you will need the [private key](https://support.metamask.io/managing-my-wallet/secret-recovery-phrase-and-private-keys/how-to-export-an-accounts-private-key/)
* ETH: You can get some [Sepolia ETH](https://www.infura.io/faucet/sepolia) and then bridge it to Ethernity&#x20;
* Solidity and CLI knowledge

### 1. Initialize a Hardhat TypeScript project <a href="#id-1.-initialize-a-hardhat-typescript-project" id="id-1.-initialize-a-hardhat-typescript-project"></a>

Open your terminal and create a new directory for your project, then navigate into it:

```
mkdir token && cd token
```

Initialize an npm project:

```
npm init -y
```

Install the necessary packages for Hardhat, TypeScript and Open Zeppelin:

```
npm install --save-dev hardhat ts-node typescript @nomiclabs/hardhat-ethers ethers @openzeppelin/contracts
```

Start a new Hardhat project with TypeScript:

```
npx hardhat init
```

When prompted, make the following selections:

* Choose "Create a TypeScript project".
* For the `.gitignore` prompt, select "Yes" (or `y`).
* For installing the projects dependencies select "Yes" (or `y`).

```
npx hardhat

888    888                      888 888               888
888    888                      888 888               888
888    888                      888 888               888
8888888888  8888b.  888d888 .d88888 88888b.   8888b.  888888
888    888      88b 888P   d88  888 888  88b      88b 888
888    888 .d888888 888    888  888 888  888 .d888888 888
888    888 888  888 888    Y88b 888 888  888 888  888 Y88b.
888    888  Y888888 888      Y88888 888  888  Y888888  Y888

👷 Welcome to Hardhat v2.18.2 👷‍

✔ What do you want to do? · Create a TypeScript project
✔ Hardhat project root: · /Users/Ethernity/token
✔ Do you want to add a .gitignore? (Y/n) · y
✔ Do you want to install this sample project's dependencies with npm (@nomicfoundation/hardhat-toolbox)? (Y/n) · y
```

### 2. Write the Token Smart Contract <a href="#id-2.-drafting-the-smart-contract" id="id-2.-drafting-the-smart-contract"></a>

In the `contracts` directory, delete the sample smart contract `Lock.sol` and then create a new file named `Token.sol.`

#### Fixed supply&#x20;

For a fixed supply, standard ERC-20 token that will mint the entire initial supply to your wallet, use this code for the Token.sol file:

```
// SPDX-License-Identifier: MIT
pragma solidity ^0.8.0;

import "@openzeppelin/contracts/token/ERC20/ERC20.sol";

contract Token is ERC20 {
    constructor(uint256 initialSupply) ERC20("My token", "TOK") {
        _mint(msg.sender, initialSupply);
    }
}
```

#### Decimals <a href="#id-3.-configuring-harhdat-for-mode" id="id-3.-configuring-harhdat-for-mode"></a>

The standard is 18 decimal places - if you want to create a token with a different decimals setting, add this function above `contract Token ...`:

```
function decimals() public view virtual override returns (uint8) {
    return 16;
} 
```

and replace the 16 with whatever decimal places you want (not recommended though, better to have the standard of 18).

#### Variable supply <a href="#id-3.-configuring-harhdat-for-mode" id="id-3.-configuring-harhdat-for-mode"></a>

Although not recommended, you can deploy a mintable token by exposing the standard \_mint function:

```
// SPDX-License-Identifier: MIT
pragma solidity ^0.8.0;

import "@openzeppelin/contracts/ownership/Ownable.sol";
import "@openzeppelin/contracts/token/ERC20/ERC20.sol";
import "@openzeppelin/contracts/token/ERC20/ERC20Mintable.sol";

contract Token is ERC20, ERC20Mintable {
    constructor(uint256 initialSupply) ERC20("My token", "TOK") {
        _mint(msg.sender, initialSupply);
    }

    function mint(address account, uint256 amount) onlyOwner returns (bool) {
        return super.mint(account, amount);
    }
}
```

Then only the owner (the wallet that deployed the contract) will get the initial supply, and will be able to mint more.

### 3. Configure Harhdat for Ethernity <a href="#id-3.-configuring-harhdat-for-mode" id="id-3.-configuring-harhdat-for-mode"></a>

Edit the `hardhat.config.ts` file to include Ethernity Chain Testnet settings:

```
import "@nomiclabs/hardhat-ethers";

import { HardhatUserConfig } from "hardhat/config";

const config: HardhatUserConfig = {
  networks: {
    ethernity-testnet: {
      url: "https://testnet.ethernitychain.io",
      chainId: 233,
      accounts: ["PRIVATE_KEY"] // DO NOT SHARE THIS!
    }
  },
  solidity: "0.8.0",
};

export default config;
```

Replace `PRIVATE_KEY` with your Ethereum wallet private key.

**IMPORTANT:** Do not push your `hardhat.config.ts` file to github or share your private key with anyone.&#x20;

### 4. Compile <a href="#id-4.-compilation" id="id-4.-compilation"></a>

Compile the smart contract:

<pre><code><strong>npx hardhat compile
</strong></code></pre>

### 5. Deploy <a href="#id-5.-deployment" id="id-5.-deployment"></a>

In the `scripts` directory, create a new file named `deploy.ts`:

```
import { ethers } from "hardhat";

async function main() {
    const Token = await ethers.getContractFactory("Token");
    const token = await Token.deploy();
    await token.deployed();
    console.log("Token deployed to:", token.address);
}

main()
  .then(() => process.exit(0))
  .catch(error => {
    console.error(error);
    process.exit(1);
  });
```

Now you can deploy the smart contract to Ethernity Testnet:

```
npx hardhat run scripts/deploy.ts --network ethernity-testnet
```

### 6. Verify <a href="#id-6.-check-your-contract-in-a-block-explorer" id="id-6.-check-your-contract-in-a-block-explorer"></a>

Follow [these instructions](https://testnet.ernscan.io/documentation/recipes/hardhat-verification) to verify the token contract.

### 7. Check <a href="#id-6.-check-your-contract-in-a-block-explorer" id="id-6.-check-your-contract-in-a-block-explorer"></a>

See your brand new Token deployed on the Ethernity Testnet block explorer (ERNScan): [https://testnet.ernscan.io](https://sepolia.explorer.mode.network/).  Enter the contract address from the command line in the search bar to see the details.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ethernity.io/tutorials/create-an-erc-20-token.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
